package edu;

import java.awt.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import javax.swing.event.*;

/**
*/
public class 
WBContainer extends JPanel implements UpdateListener 
{

  ObservableList elements;
  Dimension dim;
  Image offscreen;
  Graphics offgraphics;
  Dimension offscreensize;

  /**
  * @param l 
  * @param d
  * @see edu.ObservableList
  * @see Dimension
  */  
  public WBContainer (ObservableList l, Dimension d)
  {
    enableEvents (AWTEvent.MOUSE_EVENT_MASK | AWTEvent.MOUSE_MOTION_EVENT_MASK);
    elements = l;
    dim = d;
    elements.addUpdateListener (this);
    setOpaque(true);
  }


  Tool currentTool;

  public void setTool( Tool cTool ) { currentTool=cTool; }

  public ObservableList getElements() { return elements; }

  protected void processEvent (AWTEvent e) {
    if( currentTool!=null ) currentTool.processEvent(e);
    else super.processEvent (e);
  }

  public Dimension getMinimumSize ()   { return new Dimension (dim); }

  public Dimension getPreferredSize () { return getMinimumSize (); }

  public void updateOccurred (UpdateEvent e) { repaint (); }

  public void addElement( Element ele )
  {
    System.out.println("addElement:");
    elements.addElement(ele);
    repaint();
  }

  public void removeElement( Element ele )
  {
    System.out.println("removeElement:");
    elements.remove(ele);
    repaint();
  }

  public void
  paint (Graphics g)
  {
    //System.out.println(" paint of WEBContainer ");
    update(g);

  }// end of paint()

  public void
  paintComponent (Graphics g)
  {
    //System.out.println(" paintComponent of WEBContainer ");
    update(g);

  }// end of paint()

  public void 
  update(Graphics g) 
  {
     Dimension d = getSize();


     if ((offscreen == null) || (d.width != offscreensize.width) ||
            (d.height != offscreensize.height)) 
     {
        offscreen = createImage(d.width, d.height);
        offscreensize = d;
        offgraphics = offscreen.getGraphics();
        offgraphics.setFont(getFont());

     }// end of if

     offgraphics.setColor(getBackground());
     offgraphics.fillRect(0, 0, d.width, d.height);
 
     Rectangle clip = g.getClipBounds ();

     if (clip == null) clip = new Rectangle (getSize ());

     Enumeration els = elements.elements ();
     while (els.hasMoreElements ())
     {
       Element el = (Element) els.nextElement ();
       if ((el != null) && el.getBounds ().intersects (clip))
            el.paint (offgraphics);

     }// end of while()
 
     g.drawImage(offscreen, 0, 0, null );

  }// end of update()

}// end of WBContainer

