package org.merlin.step.nov;

import java.awt.*;
import java.util.*;

public class WBContainer extends Container implements UpdateListener {
  ObservableList elements;
  Dimension dim;
  
  public WBContainer (ObservableList l, Dimension d) {
    elements = l;
    dim = d;
    elements.addUpdateListener (this);
  }

  public Dimension getMinimumSize () {
    return new Dimension (dim);
  }

  public Dimension getPreferredSize () {
    return getMinimumSize ();
  }

  public void updateOccurred (UpdateEvent e) {
    repaint ();
  }

  public void paint (Graphics g) {
    Rectangle clip = g.getClipBounds ();
    if (clip == null)
      clip = new Rectangle (getSize ());
    Enumeration els = elements.elements ();
    while (els.hasMoreElements ()) {
      Element el = (Element) els.nextElement ();
      if ((el != null) && el.getBounds ().intersects (clip))
        el.paint (g);
    }
    super.paint (g);
  }
}
